import java.util.*;
import java.io.*;

public class Player {
    
    // ͂̂߂ Reader
    private BufferedReader reader;

    public Player(){
        reader = new BufferedReader(new InputStreamReader(System.in));
    }

    // ̎񎦂
    public PileMovementInfo nextStep(List towers) {
        while(true){
            String inputText = null;
            try{
                System.out.print("ǂ̃O𓮂܂? [0-2] ");
                inputText = reader.readLine();
                int source = Integer.parseInt(inputText);

                System.out.print("ǂ֓܂? [0-2] ");
                inputText = reader.readLine();
                int destination = Integer.parseInt(inputText);

                if(isMovable(towers, source, destination)){
                    return new PileMovementInfo(source, destination);
                }else{
                    System.out.println("܂Bx͂ĂB");
                    continue;
                }
            }catch(IOException ex){
                ex.printStackTrace();
                System.exit(1);
            }catch(NumberFormatException ex){
                System.out.println("͂ԈĂ܂Bx͂ĂB");
                continue;
            }
        }
    }

    // ~Ղړł邩ǂ̃`FbN
    private boolean isMovable(List towers, int source, int destination){
        try{
            // ړ̓ɉ~ՂȂ false
            if(((Stack)towers.get(source)).empty()){
                return false;
            }
        }catch(IndexOutOfBoundsException ex){
            // ړ̓Ȃ false
            return false;
        }

        Integer diameterSource = (Integer)((Stack)towers.get(source)).peek();

        try{
            // ړ̓ɉ~ՂȂ true
            if(((Stack)towers.get(destination)).empty()){
                return true;
            }
        }catch(IndexOutOfBoundsException ex){
            // ړ̓Ȃ false
            return false;
        }

        Integer diameterDestination = (Integer)((Stack)towers.get(destination)).peek();

        // ~Ղ̑傫̔r
        if(diameterSource.intValue() < diameterDestination.intValue()){
            return true;
        }else{
            return false;
        }
    }
}
